.186

.model small

.data

        nam db 'donut2.bmp', 0
        handle dw 0
        x dw 200
        y dw 200
        n db 0
        pos db 0
        inc_x dw 4
        inc_y dw 4
        curbank dw 0
        err_open db 'Eror opening file',13,10,36
        err_readpal db 'Eror reading palette',13,10,36
        err_readdata db 'Eror reading data',13,10,36
        err_close db 'Eror closing file',13,10,36
        buf label byte
        db 40960 dup(?)

.code

start:  mov buf, 9
        call init
        call open
        call readpal
        call setpal
        call readata
        push 0A000h
        pop es
        xor cx, cx
@@@@@1: call draw
        inc cx
        cmp cx, 9
        jna @@@6
        call readata
        xor cx, cx
        inc pos
        cmp pos, 6
        jne @@@6
        mov dx, 1078
        call setpos
        call readata
        mov pos, 0
@@@6:   call vertret
        mov ax, x
        add ax, inc_x
        mov x, ax
        mov ax, y
        add ax, inc_y
        mov y, ax
        cmp x, 384
        jne @@@2
        mov inc_x, -4
@@@2:   cmp y, 224
        jne @@@3
        mov inc_y, -4
@@@3:   cmp x, 0
        jnz @@@4
        mov inc_x, 4
@@@4:   cmp y, 0
        jnz @@@5
        mov inc_y, 4
@@@5:   mov ah, 1
        int 16h
        jz @@@@@1

        mov ax, 3
        int 10h

        call close
        mov ax, 4C00h
        int 21h

init    proc near
        mov ax, @data
        mov ds, ax
        mov ax, 4F02h
        mov bx, 101h
        int 10h
        ret
init    endp

open    proc near
        lea dx, nam
        mov ah, 3Dh
        xor al, al
        int 21h
        mov handle, ax
        jnc exit1
        mov dx, offset err_open
        call error
exit1:  ret
open    endp

close   proc near
        mov bx, handle
        mov ah, 3Eh
        int 21h
        jnc exit2
        mov dx, offset err_close
        call error
exit2:  ret
close   endp

setpos  proc near
        xor cx, cx
        mov ah, 42h
        xor al, al
        mov bx, handle
        int 21h
        ret
setpos endp

readpal proc near
        mov dx, 54
        call setpos
        mov ah, 3Fh
        mov bx, handle
        mov cx, 1024
        mov dx, offset buf
        int 21h
        jnc exit3
        mov dx, offset err_readpal
        call error
exit3:  ret
readpal endp

readata proc near
        mov ah, 3Fh
        mov bx, handle
        mov cx, 40960
        mov dx, offset buf
        int 21h
        jnc exit4
        mov dx, offset err_readdata
        call error
exit4:  xor cx, cx
        ret
readata endp

draw    proc near
        pusha
        push x
        push y
        mov si, offset buf
        shl cx, 6
        add si, cx
        mov cx, 250
@@@@1:  push cx
        mov cx, 64
@@@@2:  xor dx, dx
        mov ax, y
        mov bx, 640
        mul bx
        add ax, x
        jnc @@@@3
        inc dx
@@@@3:  cmp dx, curbank
        je @@@@4
        push ax
        mov curbank, dx
        mov ax, 4F05h
        xor bx, bx
        int 10h
        pop ax
@@@@4:  mov di, ax
        lodsb
        push cx
        mov cx, 4
        rep stosb
        pop cx
        add x, 4
        loop @@@@2
        pop cx
        inc y
        sub x, 256
        sub si, 64
        cmp n, 4
        jne @@@@5
        add si, 640
        mov n, 0
@@@@5:  inc n
        loop @@@@1
        pop y
        pop x
        popa
        ret
draw    endp

setpal  proc near
        mov cx, 0FFh
@@@1:   mov si, offset buf
        mov bp, cx
        shl bp, 2
        add si, bp
        add si, 2
        mov dx, 03C8h
        mov al, cl
        out dx, al
        inc dx
        mov al, ds:[si]
        dec si
        shr al, 2
        out dx, al
        mov al, ds:[si]
        dec si
        shr al, 2
        out dx, al
        mov al, ds:[si]
        shr al, 2
        out dx, al
        loop @@@1
        ret
setpal  endp

vertret proc near
        pusha
        cli
        mov dx, 3DAh
@@1:    in al, dx
        test al, 8
        jz @@1
@@2:    in al, dx
        test al, 8
        jnz @@2
        sti
        popa
        ret
vertret endp

error   proc near
        mov ax, 3
        int 10h
        mov ah, 9
        int 21h
        mov ax, 4C01h
        int 21h
        ret
error   endp

        end start